//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Mon May 16 17:09:53 2022 by ROOT version 6.24/06
// from TTree tree/tree
// found on file: run-0238_00_02.root
//////////////////////////////////////////////////////////

#ifndef DecayFinder_h
#define DecayFinder_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <TSelector.h>
#include <TBenchmark.h>

// Header file for the classes stored in the TTree if any.

class DecayFinder : public TSelector {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain

// Fixed size dimensions of array or collections stored in the TTree if any.

   // Declaration of leaf types
   ULong64_t       eventID;
   //Int_t           runID;
   Double_t        TOF;
   Double_t        energy;
   UInt_t          crossEnergy;
   ULong64_t       crossTime;
   Short_t         flag;
   Short_t         vetoFlag;
   Double_t        xIons;
   Double_t        yIons;
   Double_t        xBeta;
   Double_t        yBeta;
   ULong64_t       dyIonsTime[4];
   ULong64_t       dyBetaTime[4];
   Double_t        veto_f;
   Double_t        veto_r;

   // List of branches
   TBranch        *b_eventID;   //!
   //TBranch        *b_runID;   //!
   TBranch        *b_TOF;   //!
   TBranch        *b_energy;   //!
   TBranch        *b_crossTime;   //!
   TBranch        *b_crossEnergy;   //!
   TBranch        *b_flag;    //!
   TBranch        *b_vetoFlag;    //!
   TBranch        *b_xIons;   //!
   TBranch        *b_yIons;   //!
   TBranch        *b_xBeta;   //!
   TBranch        *b_yBeta;   //!
   TBranch        *b_dyIonsTime;   //!
   TBranch        *b_dyBetaTime;   //!
   TBranch        *b_veto_f;   //!
   TBranch        *b_veto_r;   //!

   DecayFinder(TTree * /*tree*/ =0) : fChain(0) { }
   virtual ~DecayFinder() { }
   virtual Int_t   Version() const { return 2; }
   virtual void    Begin(TTree *tree);
   virtual void    SlaveBegin(TTree *tree);
   virtual void    Init(TTree *tree);
   virtual Bool_t  Notify();
   virtual Bool_t  Process(Long64_t entry);
   virtual Int_t   GetEntry(Long64_t entry, Int_t getall = 0) { return fChain ? fChain->GetTree()->GetEntry(entry, getall) : 0; }
   virtual void    SetOption(const char *option) { fOption = option; }
   virtual void    SetObject(TObject *obj) { fObject = obj; }
   virtual void    SetInputList(TList *input) { fInput = input; }
   virtual TList  *GetOutputList() const { return fOutput; }
   virtual void    SlaveTerminate();
   virtual void    Terminate();

   ClassDef(DecayFinder,0);
   
   ULong64_t totNumEntry;
   
   //clock
   TBenchmark clock;
   
};

#endif

#ifdef DecayFinder_cxx
void DecayFinder::Init(TTree *tree){

   // Set branch addresses and branch pointers
   if (!tree) return;
   fChain = tree;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("eventID", &eventID, &b_eventID);
   //fChain->SetBranchAddress("runID", &runID, &b_runID);
   fChain->SetBranchAddress("TOF", &TOF, &b_TOF);
   fChain->SetBranchAddress("energy", &energy, &b_energy);
   fChain->SetBranchAddress("crossTime", &crossTime, &b_crossTime);
   fChain->SetBranchAddress("crossEnergy", &crossEnergy, &b_crossEnergy);
   fChain->SetBranchAddress("flag",   &flag, &b_flag);
   fChain->SetBranchAddress("vetoFlag",   &vetoFlag, &b_vetoFlag);
   fChain->SetBranchAddress("xIons", &xIons, &b_xIons);
   fChain->SetBranchAddress("yIons", &yIons, &b_yIons);
   fChain->SetBranchAddress("xBeta", &xBeta, &b_xBeta);
   fChain->SetBranchAddress("yBeta", &yBeta, &b_yBeta);
   fChain->SetBranchAddress("dyIonsTime",  dyIonsTime, &b_dyIonsTime);
   fChain->SetBranchAddress("dyBetaTime",  dyBetaTime, &b_dyBetaTime);
   fChain->SetBranchAddress("veto_f", &veto_f, &b_veto_f);
   fChain->SetBranchAddress("veto_r", &veto_r, &b_veto_r);
   
   totNumEntry = fChain->GetEntries();
   
   //==== clock
   clock.Reset();
   clock.Start("timer");
   
}

Bool_t DecayFinder::Notify(){

   return kTRUE;
}

void DecayFinder::SlaveTerminate(){

}


void DecayFinder::SlaveBegin(TTree * /*tree*/){
   TString option = GetOption();
}


#endif // #ifdef DecayFinder_cxx
